diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
index e03155d13..7c2fc09f4 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleBlockBreaking.java
@@ -15,18 +15,24 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 public class ParticleBlockBreaking extends Particle {
-    private final Block<?> block;
-    private final Side side;
+    private Block<?> block;
+    private Side side;
     private final @NotNull TilePos initPos = new TilePos(Integer.MAX_VALUE, Integer.MAX_VALUE, Integer.MAX_VALUE);
 
     public ParticleBlockBreaking(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
         super(world, x, y, z, xa, ya, za);
+        this.reset(world, x, y, z, xa, ya, za, block, side, meta);
+    }
+
+    public ParticleBlockBreaking reset(World world, double x, double y, double z, double xa, double ya, double za, Block<?> block, Side side, int meta) {
+        super.resetBase(world, x, y, z, xa, ya, za);
         this.side = side;
         this.block = block;
         this.tex = BlockModelDispatcher.getInstance().getDispatch(block).getParticleTexture(this.side, meta);
         this.gravity = block.blockParticleGravity;
         this.rCol = this.gCol = this.bCol = 0.6F;
         this.size /= 2.0F;
+        return this;
     }
 
     public ParticleBlockBreaking init(@NotNull TilePosc tilePos) {
@@ -44,11 +50,11 @@ public class ParticleBlockBreaking extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
@@ -78,4 +84,4 @@ public class ParticleBlockBreaking extends Particle {
 
         return lightIndex;
     }
-}
+}
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
index d1a1dbea5..f30ce7554 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleDispatcher.java
@@ -225,13 +225,13 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
                 int color = BlockColorDispatcher.getInstance().getDispatch(Blocks.FLUID_WATER_STILL).getWorldColor(world, new TilePos(x, y, z), 0);
-                return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/water_flowing"));
+                return new ParticleFluidDrip(world, x, y, z, color, TextureRegistry.getTexture("minecraft:block/fluid/water/flowing"));
             }
         });
         addDispatch("dripLava", new ParticleEntry() {
             @Override
             public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
-                return new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/lava_flowing")).setFullBright();
+                return new ParticleFluidDrip(world, x, y, z, 0xFFFFFF, TextureRegistry.getTexture("minecraft:block/fluid/lava/flowing")).setFullBright();
             }
         });
         addDispatch("ashmote", new ParticleEntry() {
@@ -282,5 +282,12 @@ public final class ParticleDispatcher extends Dispatcher<String, ParticleEntry>
                 return new ParticleRubyglassLightning(world, x, y, z, pitch, yaw);
             }
         });
+
+        addDispatch("acidBoiling", new ParticleEntry() {
+            @Override
+            public Particle newParticle(@NotNull World world, double x, double y, double z, double motionX, double motionY, double motionZ, int data) {
+                return new ParticleAcidBoiling(world, x, y, z, motionX, motionY, motionZ, true);
+            }
+        });
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
index aef5fb994..53bcb7bef 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFirefly.java
@@ -83,7 +83,7 @@ public class ParticleFirefly extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float ibr = getInternalBrightness(partialTick);
         if (ibr < 0.5f) {
             this.rCol = MathHelper.lerp(this.minR, this.midR, ibr * 2);
@@ -99,7 +99,7 @@ public class ParticleFirefly extends Particle {
         this.gCol += this.oG;
         this.bCol += this.oB;
 
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     public void renderParticleInGui(TessellatorGeneral t, float partialTick) {
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
index a2fc5df57..a95fe7539 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFlame.java
@@ -28,10 +28,10 @@ public class ParticleFlame extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float s = ((float) this.age + partialTick) / (float) this.lifetime;
         this.size = this.oSize * (1.0F - s * s * 0.5F);
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
index a319b1db4..b5b6b997b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleFluidDrip.java
@@ -59,11 +59,11 @@ public class ParticleFluidDrip extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
index 3e3255b48..b7af7e7af 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleHeart.java
@@ -27,7 +27,7 @@ public class ParticleHeart extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -36,7 +36,7 @@ public class ParticleHeart extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
index 7125f5740..53fa14750 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleItemBreaking.java
@@ -18,11 +18,11 @@ public class ParticleItemBreaking extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
             this.tex.getIconUMin() + (this.tex.getIconUSize() * this.uo / 4F), this.tex.getIconVMin() + (this.tex.getIconVSize() * this.uo / 4F), this.tex.getIconUSize() * 0.25f, this.tex.getIconVSize() * 0.25f);
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
index 79c11ed13..cda09824a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLava.java
@@ -28,10 +28,10 @@ public class ParticleLava extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = (this.age + partialTick) / this.lifetime;
         this.size = this.oSize * (1.0F - l * l);
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
index 7a768d0f6..c06799116 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleLeaf.java
@@ -9,6 +9,8 @@ import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBdc;
 
 public class ParticleLeaf extends Particle {
     public ParticleLeaf(World world, double x, double y, double z, double xa, double ya, double za) {
@@ -23,8 +25,14 @@ public class ParticleLeaf extends Particle {
     }
 
     @Override
-    public boolean collidesWithBlock(@NotNull Block<?> block, int data) {
-        return !Block.hasLogicClass(block, BlockLogicLeavesBase.class);
+    protected @Nullable AABBdc getCollisionBox(TilePos pos) {
+        Block<?> block = this.world.getBlockType(pos);
+
+        if (Block.hasLogicClass(block, BlockLogicLeavesBase.class)) {
+            return null;
+        }
+
+        return super.getCollisionBox(pos);
     }
 
     public ParticleLeaf init(@NotNull TilePos tilePos) {
@@ -52,26 +60,40 @@ public class ParticleLeaf extends Particle {
         this.xo = this.x;
         this.yo = this.y;
         this.zo = this.z;
+
         if (this.age++ >= this.lifetime) {
             this.remove();
         }
+
         this.yd -= 0.04D * this.gravity;
+
         if (this.onGround) {
             this.xd *= 0.0D;
             this.zd *= 0.0D;
         }
+
         this.move(this.xd, this.yd, this.zd);
+
+        this.xd *= 0.98D;
+        this.yd *= 0.98D;
+        this.zd *= 0.98D;
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
-            MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
-            this.tex.getIconUMin() + (this.tex.getIconUSize() * this.uo / 4F), this.tex.getIconVMin() + (this.tex.getIconVSize() * this.uo / 4F), this.tex.getIconUSize() * 0.25f, this.tex.getIconVSize() * 0.25f);
+            MathHelper.lerp(this.zo, this.z, partialTick),
+            this.size * 0.1f,
+            this.tex.getIconUMin() + (this.tex.getIconUSize() * this.uo / 4F),
+            this.tex.getIconVMin() + (this.tex.getIconVSize() * this.vo / 4F),
+            this.tex.getIconUSize() * 0.25f,
+            this.tex.getIconVSize() * 0.25f
+        );
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
index 15338e4c7..3f44568c7 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleNote.java
@@ -32,7 +32,7 @@ public class ParticleNote extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -41,7 +41,7 @@ public class ParticleNote extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
index eaaa968d6..f063bd052 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePortal.java
@@ -34,13 +34,13 @@ public class ParticlePortal extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float s = (this.age + partialTick) / this.lifetime;
         s = 1.0F - s;
         s *= s;
         s = 1.0F - s;
         this.size = this.oSize * s;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
index a0adf6a45..aed803848 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticlePuffRGB.java
@@ -38,7 +38,7 @@ public class ParticlePuffRGB extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -57,9 +57,9 @@ public class ParticlePuffRGB extends Particle {
         } else {
             lmc = getLightIndex(partialTick);
         }
-        t.setLightmapCoord1i(lmc);
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(lmc);
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick), this.size * 0.1f,
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
index d3f35182f..2ba5837e9 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleRedstoneDust.java
@@ -47,7 +47,7 @@ public class ParticleRedstoneDust extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
@@ -66,9 +66,9 @@ public class ParticleRedstoneDust extends Particle {
         } else {
             lmc = getLightIndex(partialTick);
         }
-        t.setLightmapCoord1i(lmc);
-        t.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
-        t.addParticle(
+        tessellatorParticle.setLightmapCoord1i(lmc);
+        tessellatorParticle.setColorOpaque3f(this.rCol, this.gCol, this.bCol);
+        tessellatorParticle.addParticle(
             MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick),
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
index d83182881..9ae87306d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSlimeChunk.java
@@ -18,12 +18,12 @@ public class ParticleSlimeChunk extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         if (this.tex == null) return;
         float br = 1.0f;
-        t.setLightmapCoord1i(getLightIndex(partialTick));
-        t.setColorOpaque3f(this.rCol * br, this.gCol * br, this.bCol * br);
-        t.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
+        tessellatorParticle.setLightmapCoord1i(getLightIndex(partialTick));
+        tessellatorParticle.setColorOpaque3f(this.rCol * br, this.gCol * br, this.bCol * br);
+        tessellatorParticle.addParticle(MathHelper.lerp(this.xo, this.x, partialTick),
             MathHelper.lerp(this.yo, this.y, partialTick),
             MathHelper.lerp(this.zo, this.z, partialTick),
             this.size * 0.1f,
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
index 1c15b7412..0e0ab3ff5 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSmoke.java
@@ -30,7 +30,7 @@ public class ParticleSmoke extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if (l < 0.0F) {
             l = 0.0F;
@@ -39,7 +39,7 @@ public class ParticleSmoke extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
index e89fe76f4..20a4154d8 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleSnowShovel.java
@@ -31,7 +31,7 @@ public class ParticleSnowShovel extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float l = ((this.age + partialTick) / this.lifetime) * 32F;
         if(l < 0.0F) {
             l = 0.0F;
@@ -40,7 +40,7 @@ public class ParticleSnowShovel extends Particle {
             l = 1.0F;
         }
         this.size = this.oSize * l;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
index 05518fc88..5d0b75f4d 100644
--- a/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
+++ b/game/client/src/main/java/net/minecraft/client/render/particle/ParticleVentSmoke.java
@@ -30,7 +30,7 @@ public class ParticleVentSmoke extends Particle {
     }
 
     @Override
-    public void render(@NotNull TessellatorParticle t, float partialTick) {
+    public void render(@NotNull TessellatorParticle tessellatorParticle, float partialTick) {
         float size = ((this.age + partialTick) / this.lifetime) * 32F;
         if (size < 0.0F) {
             size = 0.0F;
@@ -39,7 +39,7 @@ public class ParticleVentSmoke extends Particle {
             size = 1.0F;
         }
         this.size = this.oSize * size;
-        super.render(t, partialTick);
+        super.render(tessellatorParticle, partialTick);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
index 78e748be1..0cbf0a55f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/GLRenderer.java
@@ -49,6 +49,10 @@ public class GLRenderer {
         LIGHT_ENABLED = flag;
     }
 
+    public static boolean globalGetLightEnabled() {
+        return LIGHT_ENABLED;
+    }
+
     public static @NotNull Vector4f globalGetLightModelAmbient() {
         return LIGHT_MODEL_AMBIENT;
     }
diff --git a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
index e7f023344..9f17936e6 100644
--- a/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
+++ b/game/client/src/main/java/net/minecraft/client/render/renderer/Shaders.java
@@ -29,10 +29,11 @@ public final class Shaders {
     public static final @NotNull Shader ITEM = register("item", new Shader());
     public static final @NotNull Shader INTERFACE = register("interface", new Shader());
     public static final @NotNull Shader COLOR = register("color", new Shader());
+    public static final @NotNull Shader ACID_OVERLAY = register("acid_overlay", new Shader());
     public static final @NotNull Shader COLOR_WORLD = register("color_world", new Shader());
     public static final @NotNull Shader CLOUDS = register("clouds", new Shader());
-    public static final @NotNull ShaderGeometry PARTICLE = register("particle", new ShaderGeometry());
-    public static final @NotNull ShaderGeometry FONT = register("font", new ShaderGeometry());
+    public static final @NotNull Shader PARTICLE = register("particle", new Shader());
+    public static final @NotNull Shader FONT = register("font", new Shader());
     public static final @NotNull ShaderGeometry LINES = register("lines", new ShaderGeometry());
     public static final @NotNull ShaderGeometry LOD = register("lod", new ShaderGeometry());
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 7b02ffd9b..a49744192 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -2,7 +2,6 @@ package net.minecraft.client.render.terrain;
 
 import java.util.HashSet;
 import java.util.List;
-import java.util.Objects;
 import java.util.Set;
 
 import net.minecraft.client.render.TileEntityRenderDispatcher;
@@ -10,7 +9,6 @@ import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
 import net.minecraft.client.render.terrain.VertexBuffer.Entry;
-import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.client.render.tessellator.TessellatorTerrainImpl;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.entity.TileEntity;
@@ -18,6 +16,7 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.chunk.Chunk;
 import net.minecraft.core.world.chunk.ChunkCache;
+import net.minecraft.core.world.particle.ParticleEmitterRange;
 import net.minecraft.core.world.pos.TilePos;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
@@ -83,6 +82,15 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
                 for (pos.z = this.min.z; pos.z < this.max.z; pos.z++) {
                     for (pos.x = this.min.x; pos.x < this.max.x; pos.x++) {
                         final @NotNull Block<?> block = chunkCache.getBlockType(pos);
+
+                        if (renderPass == 0) {
+                            ParticleEmitterRange type = block.getLogic().getParticleEmitterRange();
+
+                            if (type != null) {
+                                this.getWorld().particleEmitters.add(new TilePos(pos), type);
+                            }
+                        }
+
                         if (!hasStartedDrawing) {
                             hasStartedDrawing = true;
                             TESSELLATOR.startDrawingQuads();
